#include "Fogger.hpp"

Fogger::Fogger(const uint8_t Pin)
	: _State(Fogger::Off),
	  _Pin(Pin) {

	// use pin as input until we toggle something.
	pinMode(_Pin, INPUT);
	digitalWrite(_Pin, LOW);
}

void Fogger::NextState(void) {

	String s = "";

	if (FOGGER_DEBUG)
		s += _State;

	// attach to line high first
	pinMode(_Pin, OUTPUT);
	digitalWrite(_Pin, LOW);
	delay(Fogger::PressTime);
	pinMode(_Pin, INPUT);
	delay(Fogger::ReleaseTime);

	_State = (State_t)((_State + 1) % 3);

	if (FOGGER_DEBUG) {
		s += " -> ";
		s += _State;
		Serial.println(s);
	}
}

const Fogger::State_t Fogger::GetState(void) {

	return _State;
}

void Fogger::SetState(const Fogger::State_t State) {

	while (_State != State) {
		NextState();
	}
}
