#ifndef FOGGER_HPP
#define FOGGER_HPP

#include "Arduino.h"
#include "stdint.h"

// NOTE:
// This simulates a button press on a fogger only.
// It does not generate a square signal. This is done on the fogger board itself.
// The button line is normally at 5V. During Button press it goes down to GND.

// TODO:
//
// - add feedbackpin from LED to get state: off, on, blinking
//   this can sync the class state to the real state.
//
// - determine the difference betwen on and blinking state on oscilloscope

#define FOGGER_DEBUG 0

class Fogger {

public:
	enum State_e {
		Off		 = 0,
		On		 = 1,
		Blinking = 2
	};
	typedef enum State_e State_t;

public:
	Fogger(const uint8_t Pin);

	void NextState(void);
	const Fogger::State_t GetState(void);
	void SetState(const Fogger::State_t State);

private:
	static const uint16_t PressTime = 50; // ms
	// TODO nok 30 .. 50 ok
	static const uint16_t ReleaseTime = 50; // ms
	// TODO nok ? .. 50 ok

	Fogger::State_t _State;
	uint8_t _Pin;
};

#endif
