#include "Fogger.hpp"
#include <Arduino.h>

static const String ID = "Nebler V1.0";

static const uint32_t BaudRate	= 115200;
static const uint8_t NumFoggers = 4;

Fogger foggers[NumFoggers] = {
	Fogger(A0),
	Fogger(A1),
	Fogger(A2),
	Fogger(A3),
};

void AllFoggersOff(void) {

	Serial.println("All Off");

	for (uint8_t i = 0; i < NumFoggers; i++) {
		foggers[i].SetState(Fogger::Off);
	}
}

void serialEvent(void) {

	while (Serial.available()) {
		char c = (char)Serial.read();
		// Serial.println(c);

		switch (c) {
		case '0':
			AllFoggersOff();
			break;

		case '1':
			foggers[0].NextState();
			break;

		case '2':
			foggers[1].NextState();
			break;

		case '3':
			foggers[2].NextState();
			break;

		case '4':
			foggers[3].NextState();
			break;

		default:
			break;
		}
	}
}

void setup(void) {

	Serial.begin(BaudRate);
	while (!Serial) {
		; // wait for serial port to connect. Needed for native USB port only
	}
	Serial.println(ID);
}

void loop(void) {
}
